# Changelog

## 0.2.8 *(October 13th, 2022)*
### Fixed
- Actually fix selection highlighting.
- Add tweaks to various HTML templating languages.
- Add new languages:
  - Google Sheets
  - Dictionary
### Changed
<!-- - Adjust light-plus foreground & background colors. -->
- By Language:
  - Regex 
    - mainly escaped characters & group constructs
  - TypeScript/TSX
  - YAML
  - Markdown
  - Assorted HTML template languages
- Update `README.md`.
- Update `CONTRIBUTING.md`.

## 0.2.7 *(February 10th, 2022)*
### Fixed
- Fix highlight/selection highlighting.

## 0.2.6 *(February 8th, 2022)*
### Added
- Add support for Protocol Buffers.

## 0.2.5 *(February 8th, 2022)*
### Added
- Add dotenv & project configuration class.
### Fixed
- Remove double error decoration. (don't need a border and squiggles)
- Fix *Contributing* link in readme.
### Work in Progress
- Make UI colors consistent across themes.


## 0.2.4 *(February 7th, 2022)*
### Changed
- Update dark status bar color.


## 0.2.3 *(February 7th, 2022)*
### Work in Progress
- Tweak standard (not high contrast) light theme.
- Alter primary/secondary colors for dark high contrast.


## 0.2.2 *(February 7th, 2022)*
### Changed
- Reorganize TypeScript types.
- Make JSON commas darker.
### Work in Progress
- Add light & high-contrast themes.


## 0.2.1 *(February 7th, 2022)*
### Fixed
- Fix incorrect path to theme file in package.json


## 0.2.0 *(February 7th, 2022)*

> Accidentally published `0.1.4` as stable instead of pre-release.
>
> Publishing this proper stable release for the people who update.

### Changed

- Update readme
- Move "Contributing" docs to their own file.


## 0.1.4 (pre-release) *(February 7th, 2022)*
- Migrate repository from [dunstontc/dark-plus-syntax](https://github.com/dunstontc/dark-plus-syntax.git) to [tcd/dark-plus-syntax](https://github.com/tcd/dark-plus-syntax.git).
- Add GitHub issue templates.
- [WIP] Add tests.

## 0.1.3 (pre-release) *(February 7th, 2022)*
- Review all post-refactor (post v0.1.0) color settings; fixed/updated/changed accordingly.
- Update readme.


## 0.1.0 (pre-release) *(February 5th, 2022)*
### Changed
- Major structural changes:
  - Convert the source code to Ty.peScript
  - Entirely rewrote build process.
  - Move language samples to test folder.
- Colors
  - Update yaml key colors to match JSON.
  - Due to code refactoring, fewer colors are used. Many colors may be changed.
- Misc.
  - Reformat the CHANGELOG.


## 0.0.171 *(January 22nd, 2022)*
### Changed
- Small updates to the following languages:
  - CSS
  - TSX (TypeScript React)
  - C#
  - CSHTML


## 0.0.170 *(July 30th, 2021)*
### Changed
- Update colors for custom HTML tags. (again)


## 0.0.169 *(July 27th, 2021)*
### Changed
- Roll back horrendous git diff colors.


## 0.0.168 *(July 27th, 2021)*
### Changed
- Update Ruby highlighting.
- Update CSS highlighting.
- Highlight custom elements in HTML.
- Updates to some UI components.


## 0.0.167 *(May 17, 2020)*
### Added
- Highlight the optional chain operator (`?.`) in TypeScript.
- Added `watch` NPM command to rebuild on changes.


## 0.0.166 *(May 11, 2020)*
### Changed
- Fixed issue with extension `publisher` metadata.


## 0.0.165 *(May 11, 2020)*
### Added
- Added support for scopes provided by Angular Language Service. (Kind of WIP, may change up soon. Open to feedback.)


## 0.0.164 *(March 19, 2020)*
### Changed
- Fix color of switch-case colons in TypeScript.


## 0.0.163 *(March 8, 2020)*
### Changed
- More updates to decorator highlighting.
- Updates to some TypeScript operators.


## 0.0.162 *(March 4, 2020)*
### Changed
- Fix various highlighting groups; mainly focused on scopes within TypeScript decorators.


## 0.0.161 *(February 20, 2020)*
### Changed
- Fix `keyword.control.as.tsx`, because the changes in *v0.0.158* weren't correct.


## 0.0.160 *(February 12, 2020)*
### Changed
- Consistently highlight TypeScript decorators as functions.


## 0.0.159 *(December 3, 2019)*
### Changed
- Changed indent guide color to match `Dark+`.
    - `editorIndentGuide.activeBackground`


## 0.0.158 *(November 27, 2019)*
### Added
- Instructions for adding italic comments added to readme.
- Build badge added to readme.
### Changed
- Cleaned up build process slightly.
- Update TypeScript React (TSX) highlighting to match TypeScript (TS).
    - `punctuation.accessor.jsx`
    - `keyword.control.as.tsx`
    - `punctuation.definition.typeparameters.begin.tsx`
    - `punctuation.definition.typeparameters.end.tsx`


## 0.0.157 *(November 18, 2019)*
### Added
- Shake up YAML highlighting a bit.
### Removed
- Roll back YARD highlighting for the moment. It's distracting. Feel free to open an issue if you disagree. (Or see [this comment](https://github.com/lsegal/yard/issues/1217#issuecomment-555238759))


## 0.0.156 *(November 18, 2019)*
### Added
- Add *Contributing* section to the readme (addresses [Issue #6](https://github.com/dunstontc/dark-plus-syntax/issues/6))
- Add highlighting for YARD doc comments in Ruby (in response to [YARD Issue #1217](https://github.com/lsegal/yard/issues/1217))
### Changed
- Remove bootstrap as a dev dependency (Honestly not sure when or why that was added)


## 0.0.155 *(November 16, 2019)*
### Changed
- Change highlighting for Markdown reference links.
- Organize UI colors related to *Error*, *Warning*, and*Info* elements.


## 0.0.154 *(November 7, 2019)*
### Changed
- Fix typo in changelog.
- Update language list in readme.
- Highlight Ruby HEREDOC delimiters as Strings.
- Roll back change to Diff highlighting from commit [3ec2c04](https://github.com/dunstontc/dark-plus-syntax/commit/3ec2c0400e32061eed6c7090c0248cb0da21b659). See [Issue #7](https://github.com/dunstontc/dark-plus-syntax/issues/7)
- Change Info level highlights to light blue.


## 0.0.153 *(November 5, 2019)*
### Added
- Add GraphQL support.
- Add GraphQL samples.
### Changed
- Assorted improvements to Crystal syntax highlighting.


## 0.0.152 *(October 17, 2019)*
- Update color of Keyword Arguments in Ruby.


## 0.0.151 *(September 11, 2019)*
- Update Diff colors (remove background to improve visibility).
- Add Terminal colors to theme.
- Update readme.
- Fix typo in changelog.


## 0.0.150 *(July 29, 2019)*
- Slight refactoring of project structure.
- Update colors for Error, Warning, and Info squiggles. (Red, Yellow, and Green respectively.)


## 0.0.149 *(December 23, 2018)*
- Highlight C++ bitwise shift operators (`<<`/`>>`) as Storage keywords (dark blue).


## 0.0.148 *(December 18, 2018)*
- Change colon coloring in Python.


## 0.0.147 *(November 6, 2018)*
- Add Cucumber support.
- Italicize `f` in Python f-strings.


## 0.0.146 *(October 2, 2018)*
- Tweak NGINX highlighting & update language list in readme.


## 0.0.145 *(September 17, 2018)*
- Update group name for markdown list punctuation.


## 0.0.144 *(September 17, 2018)*
- Change color for include rules in SCSS.


## 0.0.143 *(September 17, 2018)*
- Fix highlighting for include rules in SCSS.
- Italicize `!important`/`!default` in CSS et al.


## 0.0.142 *(September 14, 2018)*
- Add support for Liquid templates.


## 0.0.141 *(August 25, 2018)*
- Normalize colors for image links in Markdown.


## 0.0.140 *(August 19, 2018)*
- Normalize highlighting for address operators in Go.


## 0.0.139 *(August 14, 2018)*
- Normalize highlighting for `error` & `rune` types in Go.


## 0.0.138 *(August 9, 2018)*
- Highlight *keyword.operator.ellipsis.go* as storage (blue).


## 0.0.137 *(August 8, 2018)*
- Do highlight Go semicolons as operators.


## 0.0.136 *(August 8, 2018)*
- Don't highlight Go package names as variables.
- Don't highlight Go semicolons as operators.
- Fixed issue with paren highlighting in CSS/SCSS.


## 0.0.135 *(August 8, 2018)*
- Build with changes from *v0.0.134*.


## 0.0.134 *(August 8, 2018)*
- Golang changes:
  - Purpled bitwise operators in Go.
  - Highlight blank identifier (`_`) as a language keyword.


## 0.0.133 *(August 6, 2018)*
- Tone down colors in JS/TS doc comments.


## 0.0.132 *(August 3, 2018)*
- Highlight JS/TS rest operator as storage (blue).


## 0.0.131 *(July 31, 2018)*
- Don't highlight HTML comments as doc comments.
- Highlight JS/TS constants as variables.


## 0.0.130 *(July 22, 2018)*
- Update color of anonymous variables in Elixir.
- Highlight curly braces in JS/TS destructuring as storage (blue).


## 0.0.129 *(July 8, 2018)*
- Tweak Smarty highlighting.


## 0.0.128 *(July 3, 2018)*
- Tweaks to Haskell highlighting.
- Highlight quotes in binary strings to match `constant.character.escape` in Python.
- Don't highlight single-quoted Python docstrings.


## 0.0.127 *(July 3, 2018)*
- Add support for Haskell & Kotlin.


## 0.0.126 *(July 2, 2018)*
- Normalize Python decorator highlighting.


## 0.0.125 *(July 2, 2018)*
- Italicize magic methods in Python.
- Highlight Python unpacking operators (`*`/`**`) as builtins, not normal operators.
- Highlight JS/TS decorators as normal functions.


## 0.0.124 *(July 1, 2018)*
- Don't highlight function bodies as functions in C/C++.


## 0.0.123 *(June 27, 2018)*
- Don't highlight examples in Python docstrings.
- Do highlight single line Python docstrings.
- Do highlight Python slice operator (`:`).


## 0.0.122 *(June 26, 2018)*
- Normalize punctuation colors in C/C++.


## 0.0.121 *(June 19, 2018)*
- Dim markdown punctuation.
- Add support for [goessner/mdmath](https://github.com/goessner/mdmath)


## 0.0.120 *(June 14, 2018)*
- Don't highlight parens in Python.


## 0.0.119 *(June 12, 2018)*
- Modify color for JS constant test.


## 0.0.118 *(June 12, 2018)*
- Highlight HTML entities to match escape characters.
- Test new highlighting for JavaScript constants.


## 0.0.117 *(June 9, 2018)*
- Correctly highlight punctuation (`{}`) in JSX elements (`meta.tag.without-attributes.js`).


## 0.0.116 *(June 8, 2018)*
- Hold off on destructuring highlights for now (still needs work).


## 0.0.115 *(June 8, 2018)*
- Fixed the real cause of the issue from v0.0.114.
- Highlight JS destructuring braces as storage (blue).


## 0.0.114 *(June 6, 2018)*
- Fixed issue causing tag contents to highlight as tag names in JSX components.


## 0.0.113 *(June 1, 2018)*
- Fix issue with highlighting JSX elements in JS files.


## 0.0.112 *(May 30, 2018)*
- Test new highlighting for symbols in Elixir, Ruby, & Crystal.


## 0.0.111 *(May 30, 2018)*
- Corrected build issue from 0.0.10


## 0.0.110 *(May 30, 2018)*
- Greyed YAML comments


## 0.0.109 *(May 29, 2018)*
- Improved highlighting for Ruby regular expressions.


## 0.0.108 *(May 28, 2018)*
- Updated highlighting for punctuation in JavaScript switch statements.


## 0.0.107 *(May 27, 2018)*
- Italicize `self` in Swift.


## 0.0.106 *(May 27, 2018)*
- Highlight Swift string interpolation.


## 0.0.105 *(May 26, 2018)*
- Don't italicize global Ruby variables.
- Minor tweaks to Python (type hint) highlighting.


## 0.0.104 *(May 25, 2018)*
- Update Elixir highlighting.


## 0.0.103 *(May 21, 2018)*
- Don't highlight Rust path operators (trying to reduce noise).


## 0.0.102 *(May 21, 2018)*
- Added basic Swift support.
- Added Swift samples.


## 0.0.101 *(May 21, 2018)*
- Updated highlighting for Ruby hashes.
- Added YAML to readme.


## 0.0.100 *(May 17, 2018)*
- Highlight variables in CMake files.
- Minor updates to Ruby & Rust.
- Updated readme.


## 0.0.99 *(May 11, 2018)*
- Tweaks to highlighting for C & C++.


## 0.0.98 *(May 11, 2018)*
- Fixed highlighting for commas in Rust type params.
- Additional tweak to Debug colors.


## 0.0.97 *(May 10, 2018)*
- Vastly improved Ruby highlighting.


## 0.0.96 *(May 10, 2018)*
- Added version badge to readme.
- Additional tweak to Debug colors.


## 0.0.95 *(May 10, 2018)*
- Update Debug colors to match theme.


## 0.0.94 *(May 09, 2018)*
- Additional Crystal updates.


## 0.0.93 *(May 09, 2018)*
- Crystal updates.


## 0.0.92 *(May 08, 2018)*
- Blue~~d~~ lambdas in Ruby.


## 0.0.91 *(May 07, 2018)*
- Cyaned ERB tags.
- Added tweaks to EEX highlighting. 
- Updated readme to include ERB & EEX (embedded Ruby & Elixir).
- Updated todo.txt.


## 0.0.90 *(May 06, 2018)*
- Additional Rust tweaks.
- Updated readme.


## 0.0.89 *(May 06, 2018)*
- Changed highlighting of doc comments in Rust.


## 0.0.88 *(May 05, 2018)*
- Added language-independent defaults for:
  - `char`
  - `placeholder` (ex: `%s` in printf)


## 0.0.87 *(May 04, 2018)*
- Fixed highlighting of parens in C function calls.


## 0.0.86 *(May 03, 2018)*
- ~~One~~ Two additional modifications to C highlighting.


## 0.0.85 *(May 03, 2018)*
- One additional modification to C highlighting.


## 0.0.84 *(May 03, 2018)*
- Updated highlighting for Properties/.ini files.
- Updated C highlighting.
- Updated Elixir & Erlang highlighting.
- Updated readme.


## 0.0.83 *(May 02, 2018)*
- Updated TOML highlighting.


## 0.0.82 *(May 02, 2018)*
- Assorted Rust updates.
- Updated todo.txt & readme.


## 0.0.81 *(May 01, 2018)*
- Cyaned core types & std classes in Rust.
- Normalized `namespace separator`s in Rust to better fit the overall theme.


## 0.0.80 *(May 01, 2018)*
- Updated readme.
- Added highlighting for Crystal.
- Assorted tweaks to Ruby highlighting.


## 0.0.79 *(April 30, 2018)*
- Tweaked highlighting for Elixir interpolation.


## 0.0.78 *(April 27, 2018)*
- Added highlighting for C & Elixir.


## 0.0.77 *(April 24, 2018)*
- Cyaned Vue directives.


## 0.0.76 *(April 21, 2018)*
- Added CSV tweaks.


## 0.0.75 *(April 20, 2018)*
- Additional VimL tweaks.


## 0.0.74 *(April 20, 2018)*
- Recompiled to add changes from v0.0.73.


## 0.0.73 *(April 20, 2018)*
- Added improved support for VimL.


## 0.0.72 *(April 20, 2018)*
- Fixed highlighting for node process properties in JS/JSX.
- Fixed highlighting for arguments to `extend` in SCSS.
- Fully normalized color for template tags in both JS & JSX files.


## 0.0.71 *(April 18, 2018)*
- Fixed highlighting for node process object in JS/JSX.
- Normalized color for JSX/TSX template tags.


## 0.0.70 *(April 11, 2018)*
- Added support for todo.txt & Lisp.
- Fixed highlighting for optional operator in TS.


## 0.0.69 *(April 10, 2018)*
- Added highlighting for SCSS interpolation.
- Fixed an issue with SCSS animation attribute highlighting.
- Normalized highlighting across CSS & SCSS. 


## 0.0.68 *(April 9, 2018)*
- Highlight Go runes as characters instead of strings.


## 0.0.67 *(April 9, 2018)*
- Corrected build error *(Sorry for any inconvenience)*.


## 0.0.66 *(April 9, 2018)*
- Unitalicized core type keywords in CS.
- Assorted CS refinements.
 
## 0.0.65 *(April 8, 2018)*
- Cyan-ed embedded section tags in JSX/TSX.
- Added additional JSX samples.


## 0.0.64 *(April 7, 2018)*
- Fixed highlighting for quoted keys in TS.


## 0.0.63 *(April 7, 2018)*
- Added support for Styled Components.
- Added node_modules to .vscodeignore.


## 0.0.62 *(April 6, 2018)*
- Fixed highlighting for quoted keys in JS.


## 0.0.61 *(April 6, 2018)*
- Highlight RegEx quantifiers as numbers.
- Improve highlighting for Code's default JS & JSX syntax.


## 0.0.60 *(April 5, 2018)*
- Normalized highlighting for `super*()*` across JS, JSX, TS, & TSX.


## 0.0.59 *(April 4, 2018)*
- Added more samples.
- Fixed blockquote assorted punctuation highlighting in Markdown.


## 0.0.58 *(March 30, 2018)*
- Highlight `byte` as a *type* in Go.
- Highlight address operators as *keyword* in Go.


## 0.0.57 *(March 29, 2018)*
- Added highlight for import alias in Go.
- Fixed highlighting for SQL syntax.
- Updated readme.


## 0.0.56 *(March 29, 2018)*
- Started work on 0.1.0.
- Greened Go comments.


## 0.0.55 *(March 29, 2018)*
- Darkened Markdown fenced code block delimiters.  


## 0.0.54 *(March 29, 2018)*
- Standardized highlights for CSS selectors & pseudo-classes.


## 0.0.53 *(March 28, 2018)*
- Highlight C# lambdas as storage keywords.
- Added highlighting to YAML punctuation & constants.
- Added Cyan highlight to html template interpolations. *(But not control tags)*. 
- Made TOML & YAML operators Magenta for contrast.


## 0.0.52 *(March 24, 2018)*
- Fixed unmatched brace highlight in JSON.
- Moved `doctype` back in with the comments.
- Added highlighting for Go templates.


## 0.0.51 *(March 23, 2018)*
- Fixed 0.0.50 log date.
- Fixed link to license in readme.md.
- Made highlighting more consistent accross JS, JSX, TS, & TSX.
- Enabled eslint in workspace settings.


## 0.0.50 *(March 23, 2018)*
- Highlight shellscript shebangs as special comment.


## 0.0.49 *(March 22, 2018)*
- Highlighted JS/TS decorators & module keywords.


## 0.0.48 *(March 22, 2018)*
- Normalized JavaScript in `text.html.jinja`.


## 0.0.47 *(March 21, 2018)*
- Added Cyan highlight to template tags in assorted languages.
- Added Green highlight to *special* comments.


## 0.0.46 *(March 20, 2018)*
- Fixed a stray comment.


## 0.0.45 *(March 20, 2018)*
- Treat single & double quoted object keys as object keys in JavaScript.


## 0.0.44 *(March 20, 2018)*
- Fixed persistent Jade mismatch.
- Highlighted doc comments in TypeScript.


## 0.0.43 *(March 20, 2018)*
- More work on templating languages. *(Jade, Twig, EJS)*.
- Also tuned up TypeScript storage keywords.


## 0.0.42 *(March 20, 2018)*
- *Improved* assorted HTML-embedded languages.
- Polished up some JavaScript as well.


## 0.0.41 *(March 20, 2018)*
- Added VimL support to readme.
- Tweaked Terraform a bit.


## 0.0.40 *(March 20, 2018)*
- Added highlighting for *storage.type*.
- Minor C# updates.


## 0.0.39 *(March 20, 2018)*
- Big Refactor.
- Highlight all operators most default.


## 0.0.38 *(March 17, 2018)*
- Added highlighting storage colons in Python. *(EOL following `class` & `def`)*.


## 0.0.37 *(March 17, 2018)*
- Normalized comma highlighting in Python.


## 0.0.36 *(March 17, 2018)*
- Tweaked variable highlighting in Python.
- Also italicized `self` *(in Python)*.
- Added todo.txt.


## 0.0.35 *(March 17, 2018)*
- Added highlighting for Python operators & docstrings. 


## 0.0.34 *(March 16, 2018)*
- Final touch for Makefile highlights.


## 0.0.33 *(March 16, 2018)*
- Slight Makefile highlight revision.


## 0.0.32 *(March 16, 2018)*
- Added sensible Makefile highlights.
- Added default highlight for escaped characters.


## 0.0.31 *(March 15, 2018)*
- Even more Groovy.


## 0.0.30 *(March 15, 2018)*
- Fixed typo in index.js.
- Added highlighting for Groovy.


## 0.0.29 *(March 08, 2018)*
- Fixed commas in CSS.


## 0.0.28 *(March 07, 2018)*
- Highlighted tag names in CSS to match HTML.


## 0.0.27 *(March 06, 2018)*
- I lied; Ruby *now* finalized.


## 0.0.26 *(March 06, 2018)*
- Final touches on Ruby.


## 0.0.25 *(March 06, 2018)*
- Tweaked the aforementioned Ruby highlights.
- Highlight `module` keyword in JavaScript.


## 0.0.24 *(March 06, 2018)*
- Added highlights for Ruby operators & other elements.
- Added various samples for testing.


## 0.0.23 *(Feb 27, 2018)*
- Removed some italics.


## 0.0.22 *(Feb 27, 2018)*
- Highlight builtin Go types.


## 0.0.21 *(Feb 27, 2018)*
- Various other Go highlights.


## 0.0.20 *(Feb 27, 2018)*
- Included all Go operators.
- Included Go string formatting.


## 0.0.19 *(Feb 27, 2018)*
- Added highlighting for Go operators.
- Updated readme.


## 0.0.18 *(Feb 26, 2018)*
- Added JSX specific object key highlighting.
- Added partial UI colors.


## 0.0.17 *(Feb 21, 2018)*
- Italicize `this` in JS.


## 0.0.16 *(Feb 20, 2018)*
- Added highlighting for vue-html files.
- Added vuejs/vetur to supported plugins list in readme.


## 0.0.15 *(Feb 20, 2018)*
- Added handlebars highlighting.


## 0.0.14 *(Feb 14, 2018)*
- Looking into UI styling.
- Began adding support for @joshpeng/Sublime-Babel-VSCode


## 0.0.13 *(Feb 12, 2018)*
- Highlight JS object keys.


## 0.0.12 *(Feb 11, 2018)*
- Slight changes to C# Highlighting.
- Italicize C# types.


## 0.0.11 *(Feb 10, 2018)*
- Added badges for license, issues, and downloads to the readme.
- Highlight JS object props as variables.
- Added C# flow control highlights.


## 0.0.10 *(Feb 10, 2018)*
- Highlight `=` like all other operators in JS.


## 0.0.9 *(Feb 10, 2018)*
- Highlight parens in JS interpolation normally.


## 0.0.8 *(Feb 10, 2018)*
- Fixed JS comment highlight. Again.


## 0.0.7 *(Feb 10, 2018)*
- Fixed JS comment highlights.
- Highlight JS keyword "module"


## 0.0.6 *(Feb 9, 2018)*
- Highlight JS doc comments.


## 0.0.5 *(Feb 9, 2018)*
- Fixed compile error.


## 0.0.4 *(Feb 9, 2018)*
- Highlight JS operators.
- Added supported languages in readme.


## 0.0.3 *(Feb 9, 2018)*
- Color brackets in JS interpolation.


## 0.0.2 *(Feb 9, 2018)*
- Improved Markdown support.


## 0.0.1 *(Jan 29, 2018)*
- Added C# base support.
- Added .vscodeignore to decrease package size.
