export let vimOptions = [
    {
      "option": "aleph",
      "shortname": "al",
      "description": "ASCII code of the letter Aleph (Hebrew)"
    },
    {
      "option": "allowrevins",
      "shortname": "ari",
      "description": "allow CTRL-_ in Insert and Command-line mode"
    },
    {
      "option": "altkeymap",
      "shortname": "akm",
      "description": "for default second language (Farsi/Hebrew)"
    },
    {
      "option": "ambiwidth",
      "shortname": "ambw",
      "description": "what to do with Unicode chars of ambiguous width"
    },
    {
      "option": "autochdir",
      "shortname": "acd",
      "description": "change directory to the file in the current window"
    },
    {
      "option": "arabic",
      "shortname": "arab",
      "description": "for Arabic as a default second language"
    },
    {
      "option": "arabicshape",
      "shortname": "arshape",
      "description": "do shaping for Arabic characters"
    },
    {
      "option": "autoindent",
      "shortname": "ai",
      "description": "take indent for new line from previous line"
    },
    {
      "option": "autoread",
      "shortname": "ar",
      "description": "autom. read file when changed outside of Vim"
    },
    {
      "option": "autowrite",
      "shortname": "aw",
      "description": "automatically write file if changed"
    },
    {
      "option": "autowriteall",
      "shortname": "awa",
      "description": "as autowrite, but works with more commands"
    },
    {
      "option": "background",
      "shortname": "bg",
      "description": "dark or light, used for highlight colors"
    },
    {
      "option": "backspace",
      "shortname": "bs",
      "description": "how backspace works at start of line"
    },
    {
      "option": "backup",
      "shortname": "bk",
      "description": "keep backup file after overwriting a file"
    },
    {
      "option": "backupcopy",
      "shortname": "bkc",
      "description": "make backup as a copy, dont rename the file"
    },
    {
      "option": "backupdir",
      "shortname": "bdir",
      "description": "list of directories for the backup file"
    },
    {
      "option": "backupext",
      "shortname": "bex",
      "description": "extension used for the backup file"
    },
    {
      "option": "backupskip",
      "shortname": "bsk",
      "description": "no backup for files that match these patterns"
    },
    {
      "option": "balloondelay",
      "shortname": "bdlay",
      "description": "delay in mS before a balloon may pop up"
    },
    {
      "option": "ballooneval",
      "shortname": "beval",
      "description": "switch on balloon evaluation"
    },
    {
      "option": "balloonexpr",
      "shortname": "bexpr",
      "description": "expression to show in balloon"
    },
    {
      "option": "belloff",
      "shortname": "bo",
      "description": "do not ring the bell for these reasons"
    },
    {
      "option": "binary",
      "shortname": "bin",
      "description": "read/write/edit file in binary mode"
    },
    {
      "option": "bomb",
      "shortname": "bomb",
      "description": "prepend a Byte Order Mark to the file"
    },
    {
      "option": "breakat",
      "shortname": "brk",
      "description": "characters that may cause a line break"
    },
    {
      "option": "breakindent",
      "shortname": "bri",
      "description": "wrapped line repeats indent"
    },
    {
      "option": "breakindentopt",
      "shortname": "briopt",
      "description": "settings for breakindent"
    },
    {
      "option": "browsedir",
      "shortname": "bsdir",
      "description": "which directory to start browsing in"
    },
    {
      "option": "bufhidden",
      "shortname": "bh",
      "description": "what to do when buffer is no longer in window"
    },
    {
      "option": "buflisted",
      "shortname": "bl",
      "description": "whether the buffer shows up in the buffer list"
    },
    {
      "option": "buftype",
      "shortname": "bt",
      "description": "special type of buffer"
    },
    {
      "option": "casemap",
      "shortname": "cmp",
      "description": "specifies how case of letters is changed"
    },
    {
      "option": "cdpath",
      "shortname": "cd",
      "description": "list of directories searched with :cd"
    },
    {
      "option": "cedit",
      "shortname": "cedit",
      "description": "key used to open the command-line window"
    },
    {
      "option": "charconvert",
      "shortname": "ccv",
      "description": "expression for character encoding conversion"
    },
    {
      "option": "cindent",
      "shortname": "cin",
      "description": "do C program indenting"
    },
    {
      "option": "cinkeys",
      "shortname": "cink",
      "description": "keys that trigger indent when cindent is set"
    },
    {
      "option": "cinoptions",
      "shortname": "cino",
      "description": "how to do indenting when cindent is set"
    },
    {
      "option": "cinwords",
      "shortname": "cinw",
      "description": "words where si and cin add an indent"
    },
    {
      "option": "clipboard",
      "shortname": "cb",
      "description": "use the clipboard as the unnamed register"
    },
    {
      "option": "cmdheight",
      "shortname": "ch",
      "description": "number of lines to use for the command-line"
    },
    {
      "option": "cmdwinheight",
      "shortname": "cwh",
      "description": "height of the command-line window"
    },
    {
      "option": "colorcolumn",
      "shortname": "cc",
      "description": "columns to highlight"
    },
    {
      "option": "columns",
      "shortname": "co",
      "description": "number of columns in the display"
    },
    {
      "option": "comments",
      "shortname": "com",
      "description": "patterns that can start a comment line"
    },
    {
      "option": "commentstring",
      "shortname": "cms",
      "description": "template for comments; used for fold marker"
    },
    {
      "option": "complete",
      "shortname": "cpt",
      "description": "specify how Insert mode completion works"
    },
    {
      "option": "completefunc",
      "shortname": "cfu",
      "description": "function to be used for Insert mode completion"
    },
    {
      "option": "completeopt",
      "shortname": "cot",
      "description": "options for Insert mode completion"
    },
    {
      "option": "concealcursor",
      "shortname": "cocu",
      "description": "whether concealable text is hidden in cursor line"
    },
    {
      "option": "conceallevel",
      "shortname": "cole",
      "description": "whether concealable text is shown or hidden"
    },
    {
      "option": "confirm",
      "shortname": "cf",
      "description": "ask what to do about unsaved/read-only files"
    },
    {
      "option": "copyindent",
      "shortname": "ci",
      "description": "make autoindent use existing indent structure"
    },
    {
      "option": "cpoptions",
      "shortname": "cpo",
      "description": "flags for Vi-compatible behavior"
    },
    {
      "option": "cscopepathcomp",
      "shortname": "cspc",
      "description": "how many components of the path to show"
    },
    {
      "option": "cscopeprg",
      "shortname": "csprg",
      "description": "command to execute cscope"
    },
    {
      "option": "cscopequickfix",
      "shortname": "csqf",
      "description": "use quickfix window for cscope results"
    },
    {
      "option": "cscoperelative",
      "shortname": "csre",
      "description": "Use cscope.out path basename as prefix"
    },
    {
      "option": "cscopetag",
      "shortname": "cst",
      "description": "use cscope for tag commands"
    },
    {
      "option": "cscopetagorder",
      "shortname": "csto",
      "description": "determines :cstag search order"
    },
    {
      "option": "cscopeverbose",
      "shortname": "cpo",
      "description": "give messages when adding a cscope database"
    },
    {
      "option": "cursorbind",
      "shortname": "crb",
      "description": "move cursor in window as it moves in other windows"
    },
    {
      "option": "cursorcolumn",
      "shortname": "cuc",
      "description": "highlight the screen column of the cursor"
    },
    {
      "option": "cursorline",
      "shortname": "cul",
      "description": "highlight the screen line of the cursor"
    },
    {
      "option": "debug",
      "shortname": "debug",
      "description": "set to msg to see all error messages"
    },
    {
      "option": "define",
      "shortname": "def",
      "description": "pattern to be used to find a macro definition"
    },
    {
      "option": "delcombine",
      "shortname": "deco",
      "description": "delete combining characters on their own"
    },
    {
      "option": "dictionary",
      "shortname": "dict",
      "description": "list of file names used for keyword completion"
    },
    {
      "option": "diff",
      "shortname": "diff",
      "description": "use diff mode for the current window"
    },
    {
      "option": "diffexpr",
      "shortname": "dex",
      "description": "expression used to obtain a diff file"
    },
    {
      "option": "diffopt",
      "shortname": "dip",
      "description": "options for using diff mode"
    },
    {
      "option": "digraph",
      "shortname": "dg",
      "description": "enable the entering of digraphs in Insert mode"
    },
    {
      "option": "directory",
      "shortname": "dir",
      "description": "list of directory names for the swap file"
    },
    {
      "option": "display",
      "shortname": "dy",
      "description": "list of flags for how to display text"
    },
    {
      "option": "eadirection",
      "shortname": "ead",
      "description": "in which direction equalalways works"
    },
    {
      "option": "encoding",
      "shortname": "enc",
      "description": "encoding used internally"
    },
    {
      "option": "endofline",
      "shortname": "eol",
      "description": "write <EOL> for last line in file"
    },
    {
      "option": "equalalways",
      "shortname": "ea",
      "description": "windows are automatically made the same size"
    },
    {
      "option": "equalprg",
      "shortname": "ep",
      "description": "external program to use for = command"
    },
    {
      "option": "errorbells",
      "shortname": "eb",
      "description": "ring the bell for error messages"
    },
    {
      "option": "errorfile",
      "shortname": "ef",
      "description": "name of the errorfile for the QuickFix mode"
    },
    {
      "option": "errorformat",
      "shortname": "efm",
      "description": "description of the lines in the error file"
    },
    {
      "option": "eventignore",
      "shortname": "ei",
      "description": "autocommand events that are ignored"
    },
    {
      "option": "expandtab",
      "shortname": "et",
      "description": "use spaces when <Tab> is inserted"
    },
    {
      "option": "exrc",
      "shortname": "ex",
      "description": "read .nvimrc and .exrc in the current directory"
    },
    {
      "option": "fileencoding",
      "shortname": "fenc",
      "description": "file encoding for multi-byte text"
    },
    {
      "option": "fileencodings",
      "shortname": "fencs",
      "description": "automatically detected character encodings"
    },
    {
      "option": "fileformat",
      "shortname": "ff",
      "description": "file format used for file I/O"
    },
    {
      "option": "fileformats",
      "shortname": "ffs",
      "description": "automatically detected values for fileformat"
    },
    {
      "option": "fileignorecase",
      "shortname": "fic",
      "description": "ignore case when using file names"
    },
    {
      "option": "filetype",
      "shortname": "ft",
      "description": "type of file, used for autocommands"
    },
    {
      "option": "fillchars",
      "shortname": "fcs",
      "description": "characters to use for displaying special items"
    },
    {
      "option": "fixendofline",
      "shortname": "fixeol",
      "description": "make sure last line in file has <EOL>"
    },
    {
      "option": "fkmap",
      "shortname": "fk",
      "description": "Farsi keyboard mapping"
    },
    {
      "option": "foldclose",
      "shortname": "fcl",
      "description": "close a fold when the cursor leaves it"
    },
    {
      "option": "foldcolumn",
      "shortname": "fdc",
      "description": "width of the column used to indicate folds"
    },
    {
      "option": "foldenable",
      "shortname": "fen",
      "description": "set to display all folds open"
    },
    {
      "option": "foldexpr",
      "shortname": "fde",
      "description": "expression used when foldmethod is expr"
    },
    {
      "option": "foldignore",
      "shortname": "fdi",
      "description": "ignore lines when foldmethod is indent"
    },
    {
      "option": "foldlevel",
      "shortname": "fdl",
      "description": "close folds with a level higher than this"
    },
    {
      "option": "foldlevelstart",
      "shortname": "fdls",
      "description": "foldlevel when starting to edit a file"
    },
    {
      "option": "foldmarker",
      "shortname": "fmr",
      "description": "markers used when foldmethod is marker"
    },
    {
      "option": "foldmethod",
      "shortname": "fdm",
      "description": "folding type"
    },
    {
      "option": "foldminlines",
      "shortname": "fml",
      "description": "minimum number of lines for a fold to be closed"
    },
    {
      "option": "foldnestmax",
      "shortname": "fdn",
      "description": "maximum fold depth"
    },
    {
      "option": "foldopen",
      "shortname": "fdo",
      "description": "for which commands a fold will be opened"
    },
    {
      "option": "foldtext",
      "shortname": "fdt",
      "description": "expression used to display for a closed fold"
    },
    {
      "option": "formatexpr",
      "shortname": "fex",
      "description": "expression used with gq command"
    },
    {
      "option": "formatlistpat",
      "shortname": "flp",
      "description": "pattern used to recognize a list header"
    },
    {
      "option": "formatoptions",
      "shortname": "fo",
      "description": "how automatic formatting is to be done"
    },
    {
      "option": "formatprg",
      "shortname": "fp",
      "description": "name of external program used with gq command"
    },
    {
      "option": "fsync",
      "shortname": "fs",
      "description": "whether to invoke fsync() after file write"
    },
    {
      "option": "gdefault",
      "shortname": "gd",
      "description": "the :substitute flag g is default on"
    },
    {
      "option": "grepformat",
      "shortname": "gfm",
      "description": "format of grepprg output"
    },
    {
      "option": "grepprg",
      "shortname": "gp",
      "description": "program to use for :grep"
    },
    {
      "option": "guicursor",
      "shortname": "gcr",
      "description": "GUI: settings for cursor shape and blinking"
    },
    {
      "option": "guifont",
      "shortname": "gfn",
      "description": "GUI: Name(s) of font(s) to be used"
    },
    {
      "option": "guifontset",
      "shortname": "gfs",
      "description": "GUI: Names of multi-byte fonts to be used"
    },
    {
      "option": "guifontwide",
      "shortname": "gfw",
      "description": "list of font names for double-wide characters"
    },
    {
      "option": "guioptions",
      "shortname": "go",
      "description": "GUI: Which components and options are used"
    },
    {
      "option": "guitablabel",
      "shortname": "gtl",
      "description": "GUI: custom label for a tab page"
    },
    {
      "option": "guitabtooltip",
      "shortname": "gtt",
      "description": "GUI: custom tooltip for a tab page"
    },
    {
      "option": "helpfile",
      "shortname": "hf",
      "description": "full path name of the main help file"
    },
    {
      "option": "helpheight",
      "shortname": "hh",
      "description": "minimum height of a new help window"
    },
    {
      "option": "helplang",
      "shortname": "hlg",
      "description": "preferred help languages"
    },
    {
      "option": "hidden",
      "shortname": "hid",
      "description": "dont unload buffer when it is |abandon|ed"
    },
    {
      "option": "hlsearch",
      "shortname": "hls",
      "description": "highlight matches with last search pattern"
    },
    {
      "option": "history",
      "shortname": "hi",
      "description": "number of command-lines that are remembered"
    },
    {
      "option": "hkmap",
      "shortname": "hk",
      "description": "Hebrew keyboard mapping"
    },
    {
      "option": "hkmapp",
      "shortname": "hkp",
      "description": "phonetic Hebrew keyboard mapping"
    },
    {
      "option": "icon",
      "shortname": "icon",
      "description": "let Vim set the text of the window icon"
    },
    {
      "option": "iconstring",
      "shortname": "iconstring",
      "description": "string to use for the Vim icon text"
    },
    {
      "option": "ignorecase",
      "shortname": "ic",
      "description": "ignore case in search patterns"
    },
    {
      "option": "imcmdline",
      "shortname": "imc",
      "description": "use IM when starting to edit a command line"
    },
    {
      "option": "imdisable",
      "shortname": "imd",
      "description": "do not use the IM in any mode"
    },
    {
      "option": "iminsert",
      "shortname": "imi",
      "description": "use :lmap or IM in Insert mode"
    },
    {
      "option": "imsearch",
      "shortname": "ims",
      "description": "use :lmap or IM when typing a search pattern"
    },
    {
      "option": "include",
      "shortname": "inc",
      "description": "pattern to be used to find an include file"
    },
    {
      "option": "includeexpr",
      "shortname": "inex",
      "description": "expression used to process an include line"
    },
    {
      "option": "incsearch",
      "shortname": "is",
      "description": "highlight match while typing search pattern"
    },
    {
      "option": "indentexpr",
      "shortname": "inde",
      "description": "expression used to obtain the indent of a line"
    },
    {
      "option": "indentkeys",
      "shortname": "indk",
      "description": "keys that trigger indenting with indentexpr"
    },
    {
      "option": "infercase",
      "shortname": "inf",
      "description": "adjust case of match for keyword completion"
    },
    {
      "option": "insertmode",
      "shortname": "im",
      "description": "start the edit of a file in Insert mode"
    },
    {
      "option": "isfname",
      "shortname": "isf",
      "description": "characters included in file names and pathnames"
    },
    {
      "option": "isident",
      "shortname": "isi",
      "description": "characters included in identifiers"
    },
    {
      "option": "iskeyword",
      "shortname": "isk",
      "description": "characters included in keywords"
    },
    {
      "option": "isprint",
      "shortname": "isp",
      "description": "printable characters"
    },
    {
      "option": "joinspaces",
      "shortname": "js",
      "description": "two spaces after a period with a join command"
    },
    {
      "option": "keymap",
      "shortname": "kmp",
      "description": "name of a keyboard mapping"
    },
    {
      "option": "keymodel",
      "shortname": "km",
      "description": "enable starting/stopping selection with keys"
    },
    {
      "option": "keywordprg",
      "shortname": "kp",
      "description": "program to use for the K command"
    },
    {
      "option": "langmap",
      "shortname": "lmap",
      "description": "alphabetic characters for other language mode"
    },
    {
      "option": "langmenu",
      "shortname": "lm",
      "description": "language to be used for the menus"
    },
    {
      "option": "langremap",
      "shortname": "lrm",
      "description": "do apply langmap to mapped characters"
    },
    {
      "option": "laststatus",
      "shortname": "ls",
      "description": "tells when last window has status lines"
    },
    {
      "option": "lazyredraw",
      "shortname": "lz",
      "description": "dont redraw while executing macros"
    },
    {
      "option": "linebreak",
      "shortname": "lbr",
      "description": "wrap long lines at a blank"
    },
    {
      "option": "lines",
      "shortname": "lines",
      "description": "number of lines in the display"
    },
    {
      "option": "linespace",
      "shortname": "lsp",
      "description": "number of pixel lines to use between characters"
    },
    {
      "option": "lisp",
      "shortname": "lisp",
      "description": "automatic indenting for Lisp"
    },
    {
      "option": "lispwords",
      "shortname": "lw",
      "description": "words that change how lisp indenting works"
    },
    {
      "option": "list",
      "shortname": "list",
      "description": "show <Tab> and <EOL>"
    },
    {
      "option": "listchars",
      "shortname": "lcs",
      "description": "characters for displaying in list mode"
    },
    {
      "option": "loadplugins",
      "shortname": "lpl",
      "description": "load plugin scripts when starting up"
    },
    {
      "option": "magic",
      "shortname": "magic",
      "description": "changes special characters in search patterns"
    },
    {
      "option": "makeef",
      "shortname": "mef",
      "description": "name of the errorfile for :make"
    },
    {
      "option": "makeprg",
      "shortname": "mp",
      "description": "program to use for the :make command"
    },
    {
      "option": "matchpairs",
      "shortname": "mps",
      "description": "pairs of characters that % can match"
    },
    {
      "option": "matchtime",
      "shortname": "mat",
      "description": "tenths of a second to show matching paren"
    },
    {
      "option": "maxcombine",
      "shortname": "mco",
      "description": "maximum nr of combining characters displayed"
    },
    {
      "option": "maxfuncdepth",
      "shortname": "mfd",
      "description": "maximum recursive depth for user functions"
    },
    {
      "option": "maxmapdepth",
      "shortname": "mmd",
      "description": "maximum recursive depth for mapping"
    },
    {
      "option": "maxmem",
      "shortname": "mm",
      "description": "maximum memory (in Kbyte) used for one buffer"
    },
    {
      "option": "maxmempattern",
      "shortname": "mmp",
      "description": "maximum memory (in Kbyte) used for pattern search"
    },
    {
      "option": "maxmemtot",
      "shortname": "mmt",
      "description": "maximum memory (in Kbyte) used for all buffers"
    },
    {
      "option": "menuitems",
      "shortname": "mis",
      "description": "maximum number of items in a menu"
    },
    {
      "option": "mkspellmem",
      "shortname": "msm",
      "description": "memory used before |:mkspell| compresses the tree"
    },
    {
      "option": "modeline",
      "shortname": "ml",
      "description": "recognize modelines at start or end of file"
    },
    {
      "option": "modelines",
      "shortname": "mls",
      "description": "number of lines checked for modelines"
    },
    {
      "option": "modifiable",
      "shortname": "ma",
      "description": "changes to the text are not possible"
    },
    {
      "option": "modified",
      "shortname": "mod",
      "description": "buffer has been modified"
    },
    {
      "option": "more",
      "shortname": "more",
      "description": "pause listings when the whole screen is filled"
    },
    {
      "option": "mouse",
      "shortname": "mouse",
      "description": "enable the use of mouse clicks"
    },
    {
      "option": "mousefocus",
      "shortname": "mousef",
      "description": "keyboard focus follows the mouse"
    },
    {
      "option": "mousehide",
      "shortname": "mh",
      "description": "hide mouse pointer while typing"
    },
    {
      "option": "mousemodel",
      "shortname": "mousem",
      "description": "changes meaning of mouse buttons"
    },
    {
      "option": "mouseshape",
      "shortname": "mouses",
      "description": "shape of the mouse pointer in different modes"
    },
    {
      "option": "mousetime",
      "shortname": "mouset",
      "description": "max time between mouse double-click"
    },
    {
      "option": "nrformats",
      "shortname": "nf",
      "description": "number formats recognized for CTRL-A command"
    },
    {
      "option": "number",
      "shortname": "nu",
      "description": "print the line number in front of each line"
    },
    {
      "option": "numberwidth",
      "shortname": "nuw",
      "description": "number of columns used for the line number"
    },
    {
      "option": "omnifunc",
      "shortname": "ofu",
      "description": "function for filetype-specific completion"
    },
    {
      "option": "opendevice",
      "shortname": "odev",
      "description": "allow reading/writing devices on MS-Windows"
    },
    {
      "option": "operatorfunc",
      "shortname": "opfunc",
      "description": "function to be called for |g@| operator"
    },
    {
      "option": "packpath",
      "shortname": "pp",
      "description": "list of directories used for packages"
    },
    {
      "option": "paragraphs",
      "shortname": "para",
      "description": "nroff macros that separate paragraphs"
    },
    {
      "option": "paste",
      "shortname": "paste",
      "description": "allow pasting text"
    },
    {
      "option": "pastetoggle",
      "shortname": "pt",
      "description": "key code that causes paste to toggle"
    },
    {
      "option": "patchexpr",
      "shortname": "pex",
      "description": "expression used to patch a file"
    },
    {
      "option": "patchmode",
      "shortname": "pm",
      "description": "keep the oldest version of a file"
    },
    {
      "option": "path",
      "shortname": "pa",
      "description": "list of directories searched with gf et.al."
    },
    {
      "option": "perldll",
      "shortname": "perldll",
      "description": "name of the Perl dynamic library"
    },
    {
      "option": "preserveindent",
      "shortname": "pi",
      "description": "preserve the indent structure when reindenting"
    },
    {
      "option": "previewheight",
      "shortname": "pvh",
      "description": "height of the preview window"
    },
    {
      "option": "previewwindow",
      "shortname": "pvw",
      "description": "identifies the preview window"
    },
    {
      "option": "printdevice",
      "shortname": "pdev",
      "description": "name of the printer to be used for :hardcopy"
    },
    {
      "option": "printencoding",
      "shortname": "penc",
      "description": "encoding to be used for printing"
    },
    {
      "option": "printexpr",
      "shortname": "pexpr",
      "description": "expression used to print PostScript for :hardcopy"
    },
    {
      "option": "printfont",
      "shortname": "pfn",
      "description": "name of the font to be used for :hardcopy"
    },
    {
      "option": "printheader",
      "shortname": "pheader",
      "description": "format of the header used for :hardcopy"
    },
    {
      "option": "printmbcharset",
      "shortname": "pmbcs",
      "description": "CJK character set to be used for :hardcopy"
    },
    {
      "option": "printmbfont",
      "shortname": "pmbfn",
      "description": "font names to be used for CJK output of :hardcopy"
    },
    {
      "option": "printoptions",
      "shortname": "popt",
      "description": "controls the format of :hardcopy output"
    },
    {
      "option": "prompt",
      "shortname": "prompt",
      "description": "enable prompt in Ex mode"
    },
    {
      "option": "pumheight",
      "shortname": "ph",
      "description": "maximum height of the popup menu"
    },
    {
      "option": "pythondll",
      "shortname": "pythondll",
      "description": "name of the Python 2 dynamic library"
    },
    {
      "option": "pythonthreedll",
      "shortname": "pythonthreedlll",
      "description": "name of the Python 3 dynamic library"
    },
    {
      "option": "quoteescape",
      "shortname": "qe",
      "description": "escape characters used in a string"
    },
    {
      "option": "readonly",
      "shortname": "ro",
      "description": "disallow writing the buffer"
    },
    {
      "option": "redrawtime",
      "shortname": "rdt",
      "description": "timeout for hlsearch and |:match| highlighting"
    },
    {
      "option": "regexpengine",
      "shortname": "re",
      "description": "default regexp engine to use"
    },
    {
      "option": "relativenumber",
      "shortname": "rnu",
      "description": "show relative line number in front of each line"
    },
    {
      "option": "remap",
      "shortname": "remap",
      "description": "allow mappings to work recursively"
    },
    {
      "option": "report",
      "shortname": "report",
      "description": "threshold for reporting nr. of lines changed"
    },
    {
      "option": "revins",
      "shortname": "ri",
      "description": "inserting characters will work backwards"
    },
    {
      "option": "rightleft",
      "shortname": "rl",
      "description": "window is right-to-left oriented"
    },
    {
      "option": "rightleftcmd",
      "shortname": "rlc",
      "description": "commands for which editing works right-to-left"
    },
    {
      "option": "rubydll",
      "shortname": "rubydll",
      "description": "name of the Ruby dynamic library"
    },
    {
      "option": "ruler",
      "shortname": "ru",
      "description": "show cursor line and column in the status line"
    },
    {
      "option": "rulerformat",
      "shortname": "ruf",
      "description": "custom format for the ruler"
    },
    {
      "option": "runtimepath",
      "shortname": "rtp",
      "description": "list of directories used for runtime files"
    },
    {
      "option": "scroll",
      "shortname": "scr",
      "description": "lines to scroll with CTRL-U and CTRL-D"
    },
    {
      "option": "scrollbind",
      "shortname": "scb",
      "description": "scroll in window as other windows scroll"
    },
    {
      "option": "scrolljump",
      "shortname": "sj",
      "description": "minimum number of lines to scroll"
    },
    {
      "option": "scrolloff",
      "shortname": "so",
      "description": "minimum nr. of lines above and below cursor"
    },
    {
      "option": "scrollopt",
      "shortname": "sbo",
      "description": "how scrollbind should behave"
    },
    {
      "option": "sections",
      "shortname": "sect",
      "description": "nroff macros that separate sections"
    },
    {
      "option": "secure",
      "shortname": "secure",
      "description": "secure mode for reading .vimrc in current dir"
    },
    {
      "option": "selection",
      "shortname": "sel",
      "description": "what type of selection to use"
    },
    {
      "option": "selectmode",
      "shortname": "slm",
      "description": "when to use Select mode instead of Visual mode"
    },
    {
      "option": "sessionoptions",
      "shortname": " ssop",
      "description": "options for |:mksession|"
    },
    {
      "option": "shada",
      "shortname": "sd",
      "description": "use .shada file upon startup and exiting"
    },
    {
      "option": "shell",
      "shortname": "sh",
      "description": "name of shell to use for external commands"
    },
    {
      "option": "shellcmdflag",
      "shortname": "shcf",
      "description": "flag to shell to execute one command"
    },
    {
      "option": "shellpipe",
      "shortname": "sp",
      "description": "string to put output of :make in error file"
    },
    {
      "option": "shellquote",
      "shortname": "shq",
      "description": "quote character(s) for around shell command"
    },
    {
      "option": "shellredir",
      "shortname": "srr",
      "description": "string to put output of filter in a temp file"
    },
    {
      "option": "shellslash",
      "shortname": "ssl",
      "description": "use forward slash for shell file names"
    },
    {
      "option": "shelltemp",
      "shortname": "stmp",
      "description": "whether to use a temp file for shell commands"
    },
    {
      "option": "shellxescape",
      "shortname": "sxe",
      "description": "characters to escape when shellxquote is ("
    },
    {
      "option": "shellxquote",
      "shortname": "sxq",
      "description": "like shellquote, but include redirection"
    },
    {
      "option": "shiftround",
      "shortname": "sr",
      "description": "round indent to multiple of shiftwidth"
    },
    {
      "option": "shiftwidth",
      "shortname": "sw",
      "description": "number of spaces to use for (auto)indent step"
    },
    {
      "option": "shortmess",
      "shortname": "shm",
      "description": "list of flags, reduce length of messages"
    },
    {
      "option": "showbreak",
      "shortname": "sbr",
      "description": "string to use at the start of wrapped lines"
    },
    {
      "option": "showcmd",
      "shortname": "sc",
      "description": "show (partial) command in status line"
    },
    {
      "option": "showfulltag",
      "shortname": "sft",
      "description": "show full tag pattern when completing tag"
    },
    {
      "option": "showmatch",
      "shortname": "sm",
      "description": "briefly jump to matching bracket if insert one"
    },
    {
      "option": "showmode",
      "shortname": "smd",
      "description": "message on status line to show current mode"
    },
    {
      "option": "showtabline",
      "shortname": "stal",
      "description": "tells when the tab pages line is displayed"
    },
    {
      "option": "sidescroll",
      "shortname": "ss",
      "description": "minimum number of columns to scroll horizontal"
    },
    {
      "option": "sidescrolloff",
      "shortname": "siso",
      "description": "min. nr. of columns to left and right of cursor"
    },
    {
      "option": "signcolumn",
      "shortname": "scl",
      "description": "when to display the sign column"
    },
    {
      "option": "smartcase",
      "shortname": "scs",
      "description": "no ignore case when pattern has uppercase"
    },
    {
      "option": "smartindent",
      "shortname": "si",
      "description": "smart autoindenting for C programs"
    },
    {
      "option": "smarttab",
      "shortname": "sta",
      "description": "use shiftwidth when inserting <Tab>"
    },
    {
      "option": "softtabstop",
      "shortname": "sts",
      "description": "number of spaces that <Tab> uses while editing"
    },
    {
      "option": "spell",
      "shortname": "spell",
      "description": "enable spell checking"
    },
    {
      "option": "spellcapcheck",
      "shortname": "spc",
      "description": "pattern to locate end of a sentence"
    },
    {
      "option": "spellfile",
      "shortname": "spf",
      "description": "files where |zg| and |zw| store words"
    },
    {
      "option": "spelllang",
      "shortname": "spl",
      "description": "language(s) to do spell checking for"
    },
    {
      "option": "spellsuggest",
      "shortname": "sps",
      "description": "method(s) used to suggest spelling corrections"
    },
    {
      "option": "splitbelow",
      "shortname": "sb",
      "description": "new window from split is below the current one"
    },
    {
      "option": "splitright",
      "shortname": "spr",
      "description": "new window is put right of the current one"
    },
    {
      "option": "startofline",
      "shortname": "sol",
      "description": "commands move cursor to first non-blank in line"
    },
    {
      "option": "statusline",
      "shortname": "stl",
      "description": "custom format for the status line"
    },
    {
      "option": "suffixes",
      "shortname": "su",
      "description": "suffixes that are ignored with multiple match"
    },
    {
      "option": "suffixesadd",
      "shortname": "sua",
      "description": "suffixes added when searching for a file"
    },
    {
      "option": "swapfile",
      "shortname": "swf",
      "description": "whether to use a swapfile for a buffer"
    },
    {
      "option": "switchbuf",
      "shortname": "swb",
      "description": "sets behavior when switching to another buffer"
    },
    {
      "option": "synmaxcol",
      "shortname": "smc",
      "description": "maximum column to find syntax items"
    },
    {
      "option": "syntax",
      "shortname": "syn",
      "description": "syntax to be loaded for current buffer"
    },
    {
      "option": "tabline",
      "shortname": "tal",
      "description": "custom format for the console tab pages line"
    },
    {
      "option": "tabpagemax",
      "shortname": "tpm",
      "description": "maximum number of tab pages for |-p| and tab all"
    },
    {
      "option": "tabstop",
      "shortname": "ts",
      "description": "number of spaces that <Tab> in file uses"
    },
    {
      "option": "tagbsearch",
      "shortname": "tbs",
      "description": "use binary searching in tags files"
    },
    {
      "option": "tagcase",
      "shortname": "tc",
      "description": "how to handle case when searching in tags files"
    },
    {
      "option": "taglength",
      "shortname": "tl",
      "description": "number of significant characters for a tag"
    },
    {
      "option": "tagrelative",
      "shortname": "tr",
      "description": "file names in tag file are relative"
    },
    {
      "option": "tags",
      "shortname": "tag",
      "description": "list of file names used by the tag command"
    },
    {
      "option": "tagstack",
      "shortname": "tgst",
      "description": "push tags onto the tag stack"
    },
    {
      "option": "term",
      "shortname": "term",
      "description": "name of the terminal"
    },
    {
      "option": "termbidi",
      "shortname": "tbidi",
      "description": "terminal takes care of bi-directionality"
    },
    {
      "option": "terse",
      "shortname": "terse",
      "description": "shorten some messages"
    },
    {
      "option": "textwidth",
      "shortname": "tw",
      "description": "maximum width of text that is being inserted"
    },
    {
      "option": "thesaurus",
      "shortname": "tsr",
      "description": "list of thesaurus files for keyword completion"
    },
    {
      "option": "tildeop",
      "shortname": "top",
      "description": "tilde command ~ behaves like an operator"
    },
    {
      "option": "timeout",
      "shortname": "to",
      "description": "time out on mappings and key codes"
    },
    {
      "option": "timeoutlen",
      "shortname": "tm",
      "description": "time out time in milliseconds"
    },
    {
      "option": "title",
      "shortname": "title",
      "description": "let Vim set the title of the window"
    },
    {
      "option": "titlelen",
      "shortname": "titlelen",
      "description": "percentage of columns used for window title"
    },
    {
      "option": "titleold",
      "shortname": "titleold",
      "description": "old title, restored when exiting"
    },
    {
      "option": "titlestring",
      "shortname": "titlestring",
      "description": "string to use for the Vim window title"
    },
    {
      "option": "ttimeout",
      "shortname": "ttimeout",
      "description": "time out on mappings"
    },
    {
      "option": "ttimeoutlen",
      "shortname": "ttm",
      "description": "time out time for key codes in milliseconds"
    },
    {
      "option": "ttytype",
      "shortname": "tty",
      "description": "alias for term"
    },
    {
      "option": "undodir",
      "shortname": "udir",
      "description": "where to store undo files"
    },
    {
      "option": "undofile",
      "shortname": "udf",
      "description": "save undo information in a file"
    },
    {
      "option": "undolevels",
      "shortname": "ul",
      "description": "maximum number of changes that can be undone"
    },
    {
      "option": "undoreload",
      "shortname": "ur",
      "description": "max nr of lines to save for undo on a buffer reload"
    },
    {
      "option": "updatecount",
      "shortname": "uc",
      "description": "after this many characters flush swap file"
    },
    {
      "option": "updatetime",
      "shortname": "ut",
      "description": "after this many milliseconds flush swap file"
    },
    {
      "option": "verbose",
      "shortname": "vbs",
      "description": "give informative messages"
    },
    {
      "option": "verbosefile",
      "shortname": "vfile",
      "description": "file to write messages in"
    },
    {
      "option": "viewdir",
      "shortname": "vdir",
      "description": "directory where to store files with :mkview"
    },
    {
      "option": "viewoptions",
      "shortname": "vop",
      "description": "specifies what to save for :mkview"
    },
    {
      "option": "virtualedit",
      "shortname": "ve",
      "description": "when to use virtual editing"
    },
    {
      "option": "visualbell",
      "shortname": "vb",
      "description": "use visual bell instead of beeping"
    },
    {
      "option": "warn",
      "shortname": "warn",
      "description": "warn for shell command when buffer was changed"
    },
    {
      "option": "whichwrap",
      "shortname": "ww",
      "description": "allow specified keys to cross line boundaries"
    },
    {
      "option": "wildchar",
      "shortname": "wc",
      "description": "command-line character for wildcard expansion"
    },
    {
      "option": "wildcharm",
      "shortname": "wcm",
      "description": "like wildchar but also works when mapped"
    },
    {
      "option": "wildignore",
      "shortname": "wig",
      "description": "files matching these patterns are not completed"
    },
    {
      "option": "wildignorecase",
      "shortname": "wic",
      "description": "ignore case when completing file names"
    },
    {
      "option": "wildmenu",
      "shortname": "wmnu",
      "description": "use menu for command line completion"
    },
    {
      "option": "wildmode",
      "shortname": "wim",
      "description": "mode for wildchar command-line expansion"
    },
    {
      "option": "wildoptions",
      "shortname": "wop",
      "description": "specifies how command line completion is done"
    },
    {
      "option": "winaltkeys",
      "shortname": "wak",
      "description": "when the windows system handles ALT keys"
    },
    {
      "option": "window",
      "shortname": "wi",
      "description": "nr of lines to scroll for CTRL-F and CTRL-B"
    },
    {
      "option": "winheight",
      "shortname": "wh",
      "description": "minimum number of lines for the current window"
    },
    {
      "option": "winfixheight",
      "shortname": "wfh",
      "description": "keep window height when opening/closing windows"
    },
    {
      "option": "winfixwidth",
      "shortname": "wfw",
      "description": "keep window width when opening/closing windows"
    },
    {
      "option": "winminheight",
      "shortname": "wmh",
      "description": "minimum number of lines for any window"
    },
    {
      "option": "winminwidth",
      "shortname": "wmw",
      "description": "minimal number of columns for any window"
    },
    {
      "option": "winwidth",
      "shortname": "wiw",
      "description": "minimal number of columns for current window"
    },
    {
      "option": "wrap",
      "shortname": "wrap",
      "description": "long lines wrap and continue on the next line"
    },
    {
      "option": "wrapmargin",
      "shortname": "wm",
      "description": "chars from the right where wrapping starts"
    },
    {
      "option": "wrapscan",
      "shortname": "ws",
      "description": "searches wrap around the end of the file"
    },
    {
      "option": "write",
      "shortname": "write",
      "description": "writing to a file is allowed"
    },
    {
      "option": "writeany",
      "shortname": "wa",
      "description": "write to file with no need for ! override"
    },
    {
      "option": "writebackup",
      "shortname": "wb",
      "description": "make a backup before overwriting a file"
    },
    {
      "option": "writedelay",
      "shortname": "wd",
      "description": "delay this many msec for each char (for debug)"
    }
  ]
